import { getNextElement as f, getNextMarker as k, insert as m, createComponent as s, effect as ne, setAttribute as pe, runHydrationEvents as se, delegateEvents as ke, template as p, use as he, memo as Te, spread as Ve, mergeProps as qe, hydrate as Oe, render as Re } from "solid-js/web";
import { createSignal as O, onMount as be, onCleanup as Ie, For as Ne, Show as b, createEffect as Pe, createContext as We, useContext as Fe } from "solid-js";
import { Compartment as xe, SelectionRange as Ue, EditorSelection as Qe, RangeSetBuilder as ve, Transaction as Xe, EditorState as Ke } from "@codemirror/state";
import { markdown as Ye, markdownLanguage as Ze } from "@codemirror/lang-markdown";
import { languages as Ge } from "@codemirror/language-data";
import { EditorView as K, Decoration as V, ViewPlugin as ye, keymap as Je } from "@codemirror/view";
import { syntaxTree as le, syntaxHighlighting as et, HighlightStyle as tt } from "@codemirror/language";
import { defaultKeymap as nt, historyKeymap as ot, indentMore as rt, indentLess as it, history as at } from "@codemirror/commands";
import { tags as d } from "@lezer/highlight";
const st = "data-ink-mde-ssr-hydration-marker", lt = `[${st}]`, ct = () => ({}), q = {
  array: "[object Array]",
  object: "[object Object]",
  string: "[object String]",
  undefined: "[object Undefined]",
  window: "[object Window]"
}, dt = (e) => {
  if (Object.prototype.toString.call(e) === q.object)
    return `[object ${e.constructor.name}]`;
}, P = (e, t) => dt(e) === t, ut = (e, t) => {
  const n = /* @__PURE__ */ new WeakMap(), o = (r, i) => n.get(r) || (P(r, q.object) && n.set(r, !0), P(i, q.undefined)) ? r : P(r, q.array) && P(i, q.array) ? [...i] : P(r, q.object) && P(i, q.object) ? Object.keys(r).reduce((a, l) => (Object.hasOwnProperty.call(i, l) ? a[l] = o(r[l], i[l]) : a[l] = r[l], a), {}) : i;
  return o(e, t);
}, Y = (e, t) => ut(e, t);
var W = /* @__PURE__ */ ((e) => (e.Auto = "auto", e.Dark = "dark", e.Light = "light", e))(W || {}), ft = /* @__PURE__ */ ((e) => (e.Appearance = "appearance", e.Attribution = "attribution", e.Autocomplete = "autocomplete", e.Images = "images", e.ReadOnly = "readonly", e.Spellcheck = "spellcheck", e.Vim = "vim", e))(ft || {}), x = /* @__PURE__ */ ((e) => (e.Bold = "bold", e.Code = "code", e.CodeBlock = "code_block", e.Heading = "heading", e.Image = "image", e.Italic = "italic", e.Link = "link", e.List = "list", e.OrderedList = "ordered_list", e.Quote = "quote", e.TaskList = "task_list", e))(x || {}), J = /* @__PURE__ */ ((e) => (e.Completion = "completion", e.Default = "default", e.Grammar = "grammar", e.Language = "language", e))(J || {}), oe = /* @__PURE__ */ ((e) => (e.End = "end", e.Start = "start", e))(oe || {});
const ge = () => document.createElement("div"), $e = () => window.matchMedia("(prefers-color-scheme: dark)").matches, mt = (e) => e === W.Dark ? !0 : e === W.Light ? !1 : $e(), te = (e) => {
  const t = [
    // --ink-*
    { suffix: "border-radius", default: "0.25rem" },
    { suffix: "color", default: "currentColor" },
    { suffix: "flex-direction", default: "column" },
    { suffix: "font-family", default: "inherit" },
    // --ink-block-*
    { suffix: "block-background-color", default: "#121212", light: "#f5f5f5" },
    { suffix: "block-background-color-on-hover", default: "#0f0f0f", light: "#e0e0e0" },
    { suffix: "block-max-height", default: "20rem" },
    { suffix: "block-padding", default: "0.5rem" },
    // --ink-code-*
    { suffix: "code-background-color", default: "var(--ink-internal-block-background-color)" },
    { suffix: "code-color", default: "inherit" },
    { suffix: "code-font-family", default: "'Monaco', Courier, monospace" },
    // --ink-editor-*
    { suffix: "editor-font-size", default: "1em" },
    { suffix: "editor-line-height", default: "2em" },
    { suffix: "editor-padding", default: "0.5rem" },
    { suffix: "inline-padding", default: "0.125rem" },
    // --ink-modal-*
    { suffix: "modal-position", default: "fixed" },
    // --ink-syntax-*
    { suffix: "syntax-atom-color", default: "#d19a66" },
    { suffix: "syntax-comment-color", default: "#abb2bf" },
    { suffix: "syntax-comment-font-style", default: "italic" },
    { suffix: "syntax-emphasis-color", default: "inherit" },
    { suffix: "syntax-emphasis-font-style", default: "italic" },
    { suffix: "syntax-hashtag-background-color", default: "#222", light: "#eee" },
    { suffix: "syntax-hashtag-color", default: "inherit" },
    { suffix: "syntax-heading-color", default: "inherit" },
    { suffix: "syntax-heading-font-weight", default: "600" },
    { suffix: "syntax-heading1-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading1-font-size", default: "1.6em" },
    { suffix: "syntax-heading1-font-weight", default: "600" },
    { suffix: "syntax-heading2-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading2-font-size", default: "1.5em" },
    { suffix: "syntax-heading2-font-weight", default: "600" },
    { suffix: "syntax-heading3-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading3-font-size", default: "1.4em" },
    { suffix: "syntax-heading3-font-weight", default: "600" },
    { suffix: "syntax-heading4-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading4-font-size", default: "1.3em" },
    { suffix: "syntax-heading4-font-weight", default: "600" },
    { suffix: "syntax-heading5-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading5-font-size", default: "1.2em" },
    { suffix: "syntax-heading5-font-weight", default: "600" },
    { suffix: "syntax-heading6-color", default: "var(--ink-internal-syntax-heading-color, inherit)" },
    { suffix: "syntax-heading6-font-size", default: "1.1em" },
    { suffix: "syntax-heading6-font-weight", default: "600" },
    { suffix: "syntax-highlight-background-color", default: "#555555" },
    { suffix: "syntax-keyword-color", default: "#c678dd" },
    { suffix: "syntax-link-color", default: "inherit" },
    { suffix: "syntax-meta-color", default: "#abb2bf" },
    { suffix: "syntax-monospace-color", default: "var(--ink-internal-code-color)" },
    { suffix: "syntax-monospace-font-family", default: "var(--ink-internal-code-font-family)" },
    { suffix: "syntax-name-color", default: "#d19a66" },
    { suffix: "syntax-name-label-color", default: "#abb2bf" },
    { suffix: "syntax-name-property-color", default: "#96c0d8" },
    { suffix: "syntax-name-property-definition-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-color", default: "#e06c75" },
    { suffix: "syntax-name-variable-definition-color", default: "#e5c07b" },
    { suffix: "syntax-name-variable-local-color", default: "#d19a66" },
    { suffix: "syntax-name-variable-special-color", default: "inherit" },
    { suffix: "syntax-number-color", default: "#d19a66" },
    { suffix: "syntax-operator-color", default: "#96c0d8" },
    { suffix: "syntax-processing-instruction-color", default: "#444444", light: "#bbbbbb" },
    { suffix: "syntax-punctuation-color", default: "#abb2bf" },
    { suffix: "syntax-strikethrough-color", default: "inherit" },
    { suffix: "syntax-strikethrough-text-decoration", default: "line-through" },
    { suffix: "syntax-string-color", default: "#98c379" },
    { suffix: "syntax-string-special-color", default: "inherit" },
    { suffix: "syntax-strong-color", default: "inherit" },
    { suffix: "syntax-strong-font-weight", default: "600" },
    { suffix: "syntax-url-color", default: "#aaaaaa", light: "#666666" },
    { suffix: "toolbar-group-spacing", default: "2rem" },
    { suffix: "toolbar-item-spacing", default: "0" }
  ], n = !mt(e.options.interface.appearance);
  return t.map((o) => {
    const r = n && o.light ? o.light : o.default;
    return `--ink-internal-${o.suffix}: var(--ink-${o.suffix}, ${r});`;
  });
}, pt = (e) => [
  K.theme({}, { dark: e })
], gt = (e) => e.extensions.map((n) => n.initialValue(e)), ce = (e) => Promise.all(
  e.extensions.map((t) => t.reconfigure(e.options))
), kt = (e) => {
  const t = new xe();
  return {
    compartment: t,
    initialValue: (n) => t.of(e(n.options)),
    reconfigure: (n) => t.reconfigure(e(n))
  };
}, ht = (e) => {
  const t = new xe();
  return {
    compartment: t,
    initialValue: (n) => t.of([]),
    reconfigure: (n) => e(n, t)
  };
}, bt = () => [
  ...xt.map((e) => kt(e)),
  ...vt.map((e) => ht(e))
], xt = [
  (e) => e.plugins.reduce((n, o) => (o.type === J.Default && n.push(o.value), n), []),
  (e) => {
    const t = e.plugins.reduce((o, r) => (r.type === J.Grammar && o.push(r.value), o), []), n = e.plugins.reduce((o, r) => (r.type === J.Language && o.push(r.value), o), []);
    return Ye({
      base: Ze,
      codeLanguages: [...Ge, ...n],
      extensions: t
    });
  },
  (e) => {
    const t = e.interface.appearance === W.Dark, n = e.interface.appearance === W.Auto;
    return pt(t || n && $e());
  }
], vt = [
  async (e, t) => {
    if (e.interface.autocomplete) {
      const { autocomplete: n } = await import("./autocomplete-294208a2.js");
      return t.reconfigure(n(e));
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.images) {
      const { images: n } = await import("./images-1efb4104.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.lists) {
      const { lists: n } = await import("./lists-45709764.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.placeholder) {
      const { placeholder: n } = await import("./placeholder-985d86f2.js");
      return t.reconfigure(n(e.placeholder));
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.readonly) {
      const { readonly: n } = await import("./readonly-28fcecea.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.search) {
      const { search: n } = await import("./search-72d4d407.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.interface.spellcheck) {
      const { spellcheck: n } = await import("./spellcheck-9deeebb9.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  },
  async (e, t) => {
    if (e.vim) {
      const { vim: n } = await import("./vim-96332d1a.js");
      return t.reconfigure(n());
    }
    return t.reconfigure([]);
  }
], yt = () => {
  const e = {
    queue: [],
    workload: 0
  }, t = async () => {
    const n = e.queue.pop();
    n && (await n(), e.workload--, await t());
  };
  return {
    enqueue: (n) => new Promise((o, r) => {
      const i = async () => {
        try {
          await n(), o();
        } catch (a) {
          r(a);
        }
      };
      e.queue.push(i), e.workload++, !(e.workload > 1) && t();
    })
  };
}, re = () => {
  const e = {
    doc: "",
    files: {
      clipboard: !1,
      dragAndDrop: !1,
      handler: () => {
      },
      injectMarkup: !0,
      types: ["image/*"]
    },
    hooks: {
      afterUpdate: () => {
      },
      beforeUpdate: () => {
      }
    },
    interface: {
      appearance: W.Auto,
      attribution: !0,
      autocomplete: !1,
      images: !1,
      lists: !1,
      readonly: !1,
      spellcheck: !0,
      toolbar: !1
    },
    placeholder: "",
    plugins: [],
    readability: !1,
    search: !0,
    selections: [],
    toolbar: {
      bold: !0,
      code: !0,
      codeBlock: !0,
      heading: !0,
      image: !0,
      italic: !0,
      link: !0,
      list: !0,
      orderedList: !0,
      quote: !0,
      taskList: !0,
      upload: !1
    },
    vim: !1
  };
  return {
    doc: "",
    editor: {},
    extensions: bt(),
    options: e,
    root: ge(),
    target: ge(),
    workQueue: yt()
  };
}, $t = (e) => Y(re(), e), de = (e, t = {}) => {
  const [n, o] = O($t({ ...t, doc: e.doc || "", options: e }));
  return [n, o];
}, wt = ([e]) => {
  const { editor: t } = e();
  t.destroy();
}, ie = ([e]) => {
  const { editor: t } = e();
  t.hasFocus || t.focus();
}, we = (e) => {
  const t = e.map((n) => Ue.fromJSON({ anchor: n.start, head: n.end }));
  return Qe.create(t);
}, _e = (e) => e.ranges.map((n) => ({
  end: n.anchor < n.head ? n.head : n.anchor,
  start: n.head < n.anchor ? n.head : n.anchor
})), A = (e) => ({ ...{
  block: !1,
  line: !1,
  multiline: !1,
  nodes: [],
  prefix: "",
  prefixStates: [],
  suffix: ""
}, ...e }), _t = {
  [x.Bold]: A({
    nodes: ["StrongEmphasis"],
    prefix: "**",
    suffix: "**"
  }),
  [x.Code]: A({
    nodes: ["InlineCode"],
    prefix: "`",
    suffix: "`"
  }),
  [x.CodeBlock]: A({
    block: !0,
    nodes: ["FencedCode"],
    prefix: "```\n",
    suffix: "\n```"
  }),
  [x.Heading]: A({
    multiline: !0,
    nodes: ["ATXHeading1", "ATXHeading2", "ATXHeading3", "ATXHeading4", "ATXHeading5", "ATXHeading6"],
    prefix: "# ",
    prefixStates: ["# ", "## ", "### ", "#### ", "##### ", "###### ", ""]
  }),
  [x.Image]: A({
    nodes: ["Image"],
    prefix: "![](",
    suffix: ")"
  }),
  [x.Italic]: A({
    nodes: ["Emphasis"],
    prefix: "*",
    suffix: "*"
  }),
  [x.Link]: A({
    nodes: ["Link"],
    prefix: "[](",
    suffix: ")"
  }),
  [x.OrderedList]: A({
    line: !0,
    multiline: !0,
    nodes: ["OrderedList"],
    prefix: "1. "
  }),
  [x.Quote]: A({
    line: !0,
    multiline: !0,
    nodes: ["Blockquote"],
    prefix: "> "
  }),
  [x.TaskList]: A({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- [ ] "
  }),
  [x.List]: A({
    line: !0,
    multiline: !0,
    nodes: ["BulletList"],
    prefix: "- "
  })
}, Ct = ({ editor: e, selection: t }) => {
  let n = t.start;
  const o = [];
  for (; n <= t.end; ) {
    const r = e.lineBlockAt(n), i = Math.max(t.start, r.from), a = Math.min(t.end, r.to);
    o.push({ start: i, end: a }), n = r.to + 1;
  }
  return o;
}, St = ({ editor: e, formatDefinition: t, selection: n }) => {
  if (!e || !t)
    return n || { start: 0, end: 0 };
  const o = n || _e(e.state.selection).pop() || { start: 0, end: 0 };
  if (t.block || t.line || t.multiline) {
    const a = e.lineBlockAt(o.start).from, l = e.lineBlockAt(o.end).to;
    return { start: a, end: l };
  }
  const r = e.state.wordAt(o.start)?.from || o.start, i = e.state.wordAt(o.end)?.to || o.end;
  return { start: r, end: i };
}, Ce = (e) => e.editor.state.sliceDoc(e.selection.start, e.selection.end), Lt = (e, t, n) => Mt(e, n).find(({ type: r }) => t.nodes.includes(r.name)), Mt = (e, t) => {
  const n = [];
  return le(e.state).iterate({
    from: t.start,
    to: t.end,
    enter: ({ type: o, from: r, to: i }) => {
      n.push({ type: o, from: r, to: i });
    }
  }), n;
}, ue = (e) => {
  const t = Ce(e), n = e.formatDefinition.prefix.length, o = e.formatDefinition.suffix.length * -1 || t.length, r = t.slice(n, o);
  return [{ from: e.selection.start, to: e.selection.end, insert: r }];
}, Ht = (e) => {
  if (e.node) {
    const t = e.node.from, n = e.node.to;
    return ue({ ...e, selection: { start: t, end: n } });
  } else {
    const t = e.formatDefinition.prefix, n = e.formatDefinition.suffix;
    return [
      { from: e.selection.start, insert: t },
      { from: e.selection.end, insert: n }
    ];
  }
}, At = (e) => {
  const t = Ct(e), n = [];
  return t.forEach((o) => {
    const r = Se({ ...e, selection: o });
    n.push(...r);
  }), n;
}, Se = (e) => {
  const t = e.formatDefinition.prefixStates.length > 0, n = Ce(e);
  if (e.node && t) {
    const o = e.formatDefinition.prefixStates.find((r) => n.startsWith(r));
    if (o) {
      const r = e.formatDefinition.prefixStates.indexOf(o), i = e.formatDefinition.prefixStates[r + 1], a = n.replace(new RegExp(`^${o}`), i);
      return [{ from: e.selection.start, to: e.selection.end, insert: a }];
    }
  } else if (e.node && n.startsWith(e.formatDefinition.prefix))
    return ue(e);
  return [{ from: e.selection.start, insert: e.formatDefinition.prefix }];
}, zt = (e) => {
  if (e.node) {
    const t = e.node.from, n = e.node.to;
    return ue({ ...e, selection: { start: t, end: n } });
  } else {
    const { formatDefinition: t, selection: n } = e, o = Array.isArray(t.prefix) ? t.prefix[0] : t.prefix, r = t.suffix;
    return [
      { from: n.start, insert: o },
      { from: n.end, insert: r }
    ];
  }
}, Et = (e) => e.formatDefinition.block ? Ht(e) : e.formatDefinition.multiline ? At(e) : e.formatDefinition.line ? Se(e) : zt(e), Le = ([e], t, { selection: n } = {}) => {
  const { editor: o } = e(), r = _t[t], i = St({ editor: o, formatDefinition: r, selection: n }), a = Lt(o, r, i), c = Et({
    editor: o,
    formatDefinition: r,
    node: a,
    selection: i
  }), u = c.reduce((w, _) => {
    const L = _.insert.length - ((_.to || _.from) - _.from);
    return w + L;
  }, 0), v = e().editor.state.update({ changes: c, selection: { head: i.start, anchor: i.end + u } });
  e().editor.dispatch(v);
}, Bt = ([e]) => {
  const { editor: t } = e();
  return t.state.sliceDoc();
}, fe = ([e]) => {
  const { editor: t } = e();
  return _e(t.state.selection);
}, ee = ([e, t], n, o, r = !1) => {
  const { editor: i } = e();
  let a = o?.start, l = o?.end || o?.start;
  if (typeof a > "u") {
    const u = fe([e, t]).pop();
    a = u.start, l = u.end;
  }
  const c = { changes: { from: a, to: l, insert: n } };
  if (r) {
    const u = a === l ? a + n.length : a, v = a + n.length;
    Object.assign(c, { selection: { anchor: u, head: v } });
  }
  i.dispatch(
    i.state.update(c)
  );
}, jt = [
  "Blockquote"
], Dt = V.line({ attributes: { class: "cm-blockquote" } }), Tt = V.line({ attributes: { class: "cm-blockquote-open" } }), Vt = V.line({ attributes: { class: "cm-blockquote-close" } }), qt = ye.define((e) => ({
  update: () => Ot(e)
}), { decorations: (e) => e.update() }), Ot = (e) => {
  const t = new ve(), n = le(e.state);
  for (const o of e.visibleRanges)
    for (let r = o.from; r < o.to; ) {
      const i = e.state.doc.lineAt(r);
      n.iterate({
        enter({ type: a, from: l, to: c }) {
          if (a.name !== "Document" && jt.includes(a.name)) {
            t.add(i.from, i.from, Dt);
            const u = e.state.doc.lineAt(l), v = e.state.doc.lineAt(c);
            return u.number === i.number && t.add(i.from, i.from, Tt), v.number === i.number && t.add(i.from, i.from, Vt), !1;
          }
        },
        from: i.from,
        to: i.to
      }), r = i.to + 1;
    }
  return t.finish();
}, Rt = () => [
  qt
], It = [
  "CodeBlock",
  "FencedCode",
  "HTMLBlock",
  "CommentBlock"
], F = {
  // Prevent spellcheck in all code blocks. The Grammarly extension might not respect these values.
  "data-enable-grammarly": "false",
  "data-gramm": "false",
  "data-grammarly-skip": "true",
  spellcheck: "false"
}, Nt = V.line({ attributes: { ...F, class: "cm-codeblock" } }), Pt = V.line({ attributes: { ...F, class: "cm-codeblock-open" } }), Wt = V.line({ attributes: { ...F, class: "cm-codeblock-close" } }), Ft = V.mark({ attributes: { ...F, class: "cm-code" } }), Ut = V.mark({ attributes: { ...F, class: "cm-code cm-code-open" } }), Qt = V.mark({ attributes: { ...F, class: "cm-code cm-code-close" } }), Xt = ye.define((e) => ({
  update: () => Kt(e)
}), { decorations: (e) => e.update() }), Kt = (e) => {
  const t = new ve(), n = le(e.state);
  for (const o of e.visibleRanges)
    for (let r = o.from; r < o.to; ) {
      const i = e.state.doc.lineAt(r);
      let a;
      n.iterate({
        enter({ type: l, from: c, to: u }) {
          if (l.name !== "Document")
            if (It.includes(l.name)) {
              t.add(i.from, i.from, Nt);
              const v = e.state.doc.lineAt(c), w = e.state.doc.lineAt(u);
              return v.number === i.number && t.add(i.from, i.from, Pt), w.number === i.number && t.add(i.from, i.from, Wt), !1;
            } else
              l.name === "InlineCode" ? a = { from: c, to: u, innerFrom: c, innerTo: u } : l.name === "CodeMark" && (c === a.from ? (a.innerFrom = u, t.add(c, u, Ut)) : u === a.to && (a.innerTo = c, t.add(a.innerFrom, a.innerTo, Ft), t.add(c, u, Qt)));
        },
        from: i.from,
        to: i.to
      }), r = i.to + 1;
    }
  return t.finish();
}, Yt = () => [
  Xt
], Zt = () => [
  K.editorAttributes.of({
    class: "ink-mde-container"
  }),
  K.contentAttributes.of({
    class: "ink-mde-editor-content"
  })
  // Todo: Maybe open a PR to add scrollerAttributes?
], Gt = () => [
  ...Zt()
], Jt = [
  {
    key: "Tab",
    run: ({ state: e, dispatch: t }) => e.selection.ranges.some((n) => !n.empty) ? rt({ state: e, dispatch: t }) : (t(
      e.update(e.replaceSelection("  "), {
        scrollIntoView: !0,
        annotations: Xe.userEvent.of("input")
      })
    ), !0),
    shift: it
  }
], en = () => Je.of([
  ...Jt,
  ...nt,
  ...ot
]), tn = () => K.lineWrapping, nn = () => [
  et(
    tt.define([
      // ordered by lowest to highest precedence
      {
        tag: d.atom,
        color: "var(--ink-internal-syntax-atom-color)"
      },
      {
        tag: d.meta,
        color: "var(--ink-internal-syntax-meta-color)"
      },
      // emphasis types
      {
        tag: d.emphasis,
        color: "var(--ink-internal-syntax-emphasis-color)",
        fontStyle: "var(--ink-internal-syntax-emphasis-font-style)"
      },
      {
        tag: d.strong,
        color: "var(--ink-internal-syntax-strong-color)",
        fontWeight: "var(--ink-internal-syntax-strong-font-weight)"
      },
      {
        tag: d.strikethrough,
        color: "var(--ink-internal-syntax-strikethrough-color)",
        textDecoration: "var(--ink-internal-syntax-strikethrough-text-decoration)"
      },
      // comment group
      {
        tag: d.comment,
        color: "var(--ink-internal-syntax-comment-color)",
        fontStyle: "var(--ink-internal-syntax-comment-font-style)"
      },
      // monospace
      {
        tag: d.monospace,
        color: "var(--ink-internal-syntax-code-color)",
        fontFamily: "var(--ink-internal-syntax-code-font-family)"
      },
      // name group
      {
        tag: d.name,
        color: "var(--ink-internal-syntax-name-color)"
      },
      {
        tag: d.labelName,
        color: "var(--ink-internal-syntax-name-label-color)"
      },
      {
        tag: d.propertyName,
        color: "var(--ink-internal-syntax-name-property-color)"
      },
      {
        tag: d.definition(d.propertyName),
        color: "var(--ink-internal-syntax-name-property-definition-color)"
      },
      {
        tag: d.variableName,
        color: "var(--ink-internal-syntax-name-variable-color)"
      },
      {
        tag: d.definition(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-definition-color)"
      },
      {
        tag: d.local(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-local-color)"
      },
      {
        tag: d.special(d.variableName),
        color: "var(--ink-internal-syntax-name-variable-special-color)"
      },
      // headings
      {
        tag: d.heading,
        color: "var(--ink-internal-syntax-heading-color)",
        fontWeight: "var(--ink-internal-syntax-heading-font-weight)"
      },
      {
        tag: d.heading1,
        color: "var(--ink-internal-syntax-heading1-color)",
        fontSize: "var(--ink-internal-syntax-heading1-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading1-font-weight)"
      },
      {
        tag: d.heading2,
        color: "var(--ink-internal-syntax-heading2-color)",
        fontSize: "var(--ink-internal-syntax-heading2-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading2-font-weight)"
      },
      {
        tag: d.heading3,
        color: "var(--ink-internal-syntax-heading3-color)",
        fontSize: "var(--ink-internal-syntax-heading3-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading3-font-weight)"
      },
      {
        tag: d.heading4,
        color: "var(--ink-internal-syntax-heading4-color)",
        fontSize: "var(--ink-internal-syntax-heading4-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading4-font-weight)"
      },
      {
        tag: d.heading5,
        color: "var(--ink-internal-syntax-heading5-color)",
        fontSize: "var(--ink-internal-syntax-heading5-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading5-font-weight)"
      },
      {
        tag: d.heading6,
        color: "var(--ink-internal-syntax-heading6-color)",
        fontSize: "var(--ink-internal-syntax-heading6-font-size)",
        fontWeight: "var(--ink-internal-syntax-heading6-font-weight)"
      },
      // contextual tag types
      {
        tag: d.keyword,
        color: "var(--ink-internal-syntax-keyword-color)"
      },
      {
        tag: d.number,
        color: "var(--ink-internal-syntax-number-color)"
      },
      {
        tag: d.operator,
        color: "var(--ink-internal-syntax-operator-color)"
      },
      {
        tag: d.punctuation,
        color: "var(--ink-internal-syntax-punctuation-color)"
      },
      {
        tag: d.link,
        color: "var(--ink-internal-syntax-link-color)"
      },
      {
        tag: d.url,
        color: "var(--ink-internal-syntax-url-color)"
      },
      // string group
      {
        tag: d.string,
        color: "var(--ink-internal-syntax-string-color)"
      },
      {
        tag: d.special(d.string),
        color: "var(--ink-internal-syntax-string-special-color)"
      },
      // processing instructions
      {
        tag: d.processingInstruction,
        color: "var(--ink-internal-syntax-processing-instruction-color)"
      }
    ])
  )
], on = (e) => {
  if (e.length > 0)
    return we(e);
}, Me = (e) => Ke.create({
  doc: e.options.doc,
  selection: on(e.options.selections),
  extensions: [
    Rt(),
    Yt(),
    at(),
    Gt(),
    en(),
    tn(),
    nn(),
    ...gt(e)
  ]
}), rn = ([e, t], n) => {
  t(Y(e(), { options: { doc: n } })), e().editor.setState(Me(e()));
}, an = ([e]) => e().options, sn = async ([e, t], n) => {
  const { workQueue: o } = e();
  return t(Y(e(), { options: n })), o.enqueue(async () => {
    const r = await ce(e());
    e().editor.dispatch({ effects: r });
  });
}, He = (e, t = {}) => {
  if (t.selections)
    return Ae(e, t.selections);
  if (t.selection)
    return ae(e, t.selection);
  if (t.at)
    return ln(e, t.at);
}, ln = (e, t) => {
  const [n] = e;
  if (t === oe.Start)
    return ae(e, { start: 0, end: 0 });
  if (t === oe.End) {
    const o = n().editor.state.doc.length;
    return ae(e, { start: o, end: o });
  }
}, Ae = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      selection: we(t)
    })
  );
}, ae = (e, t) => Ae(e, [t]), cn = ([e], t) => {
  const { editor: n } = e();
  n.dispatch(
    n.state.update({
      changes: {
        from: 0,
        to: n.state.doc.length,
        insert: t
      }
    })
  );
}, dn = ([e, t], { after: n, before: o, selection: r }) => {
  const { editor: i } = e(), a = r || fe([e, t]).pop() || { start: 0, end: 0 }, l = i.state.sliceDoc(a.start, a.end);
  ee([e, t], `${o}${l}${n}`, a), He([e, t], { selections: [{ start: a.start + o.length, end: a.end + o.length }] });
}, ze = (e) => ({
  destroy: wt.bind(void 0, e),
  focus: ie.bind(void 0, e),
  format: Le.bind(void 0, e),
  getDoc: Bt.bind(void 0, e),
  insert: ee.bind(void 0, e),
  load: rn.bind(void 0, e),
  options: an.bind(void 0, e),
  reconfigure: sn.bind(void 0, e),
  select: He.bind(void 0, e),
  selections: fe.bind(void 0, e),
  update: cn.bind(void 0, e),
  wrap: dn.bind(void 0, e)
}), un = `.ink-drop-zone{align-items:center;background-color:#00000080;color:var(--ink-internal-color);display:flex;inset:0;justify-content:center;position:var(--ink-internal-modal-position);z-index:100}.ink-drop-zone:not(.visible){display:none}.ink-drop-zone-modal{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);box-sizing:border-box;height:100%;max-height:20rem;max-width:40rem;padding:1rem;position:relative;width:100%}.ink-drop-zone-hide{cursor:pointer;height:1.75rem;position:absolute;right:.25rem;top:.25rem;width:1.75rem}.ink-drop-zone-hide svg{background-color:var(--ink-internal-block-background-color)}.ink-drop-zone-droppable-area{align-items:center;border:.2rem dashed var(--ink-internal-color);border-radius:.125rem;box-sizing:border-box;display:flex;flex-direction:column;font-size:1.25em;gap:1rem;height:100%;justify-content:center;padding:1rem;text-align:center}.ink-drop-zone-file-preview{align-items:center;display:flex;flex-wrap:wrap;gap:.5rem;max-width:25.5rem}.ink-drop-zone-file-preview-image{border:.125rem solid #222;border-radius:.125rem;box-sizing:border-box;height:6rem;object-fit:cover;padding:.5rem;width:6rem}
`, fn = /* @__PURE__ */ p("<span>uploading files...</span>", 2), mn = /* @__PURE__ */ p('<div class="ink-drop-zone"><style></style><div class="ink-drop-zone-modal"><div class="ink-drop-zone-droppable-area"><div class="ink-drop-zone-file-preview"></div><!#><!/></div><div class="ink-drop-zone-hide"><svg xmlns="http://www.w3.org/2000/svg" fill="none" viewBox="0 0 24 24" stroke="currentColor"><path stroke-linecap="round" stroke-linejoin="round" stroke-width="2" d="M10 14l2-2m0 0l2-2m-2 2l-2-2m2 2l2 2m7-2a9 9 0 11-18 0 9 9 0 0118 0z"></path></svg></div></div></div>', 18), pn = /* @__PURE__ */ p('<img class="ink-drop-zone-file-preview-image">', 1), gn = /* @__PURE__ */ p("<span>drop files here</span>", 2), kn = () => {
  const [e, t] = O(0), [n, o] = O([]), [r, i] = O(!1), [a, l] = O(!1), [c, u] = U(), v = () => {
    l(!1);
  }, w = (h) => {
    if (c().options.files.dragAndDrop) {
      h.preventDefault(), h.stopPropagation();
      const y = h.dataTransfer;
      y?.files ? Q(y.files) : (t(0), l(!1), o([]));
    }
  }, _ = (h) => {
    c().options.files.dragAndDrop && (h.preventDefault(), t(e() + 1), l(!0));
  }, L = (h) => {
    c().options.files.dragAndDrop && (h.preventDefault(), t(e() - 1), e() === 0 && l(!1));
  }, B = (h) => {
    c().options.files.dragAndDrop && (h.preventDefault(), l(!0));
  }, R = (h) => {
    c().options.files.dragAndDrop && (h.preventDefault(), t(0), l(!1));
  }, I = (h) => {
    if (c().options.files.clipboard) {
      h.preventDefault();
      const y = h.clipboardData;
      y?.files && y.files.length > 0 && Q(y.files);
    }
  }, Q = (h) => {
    Array.from(h).forEach((y) => {
      o([...n(), y]);
    }), i(!0), l(!0), Promise.resolve(c().options.files.handler(h)).then((y) => {
      if (c().options.files.injectMarkup && y) {
        const X = `![](${y})`;
        ee([c, u], X);
      }
    }).finally(() => {
      t(0), i(!1), l(!1), o([]);
    });
  };
  return be(() => {
    document.addEventListener("dragenter", _), document.addEventListener("dragleave", L), document.addEventListener("dragover", B), document.addEventListener("drop", R), c().root.addEventListener("paste", I);
  }), Ie(() => {
    document.removeEventListener("dragenter", _), document.removeEventListener("dragleave", L), document.removeEventListener("dragover", B), document.removeEventListener("drop", R), c().root.removeEventListener("paste", I);
  }), (() => {
    const h = f(mn), y = h.firstChild, X = y.nextSibling, N = X.firstChild, g = N.firstChild, j = g.nextSibling, [C, D] = k(j.nextSibling), T = N.nextSibling;
    return y.textContent = un, N.addEventListener("drop", w), m(g, s(Ne, {
      get each() {
        return n().slice(0, 8);
      },
      children: ($) => (() => {
        const H = f(pn);
        return ne((S) => {
          const z = $.name, E = URL.createObjectURL($);
          return z !== S._v$ && pe(H, "alt", S._v$ = z), E !== S._v$2 && pe(H, "src", S._v$2 = E), S;
        }, {
          _v$: void 0,
          _v$2: void 0
        }), H;
      })()
    })), m(N, s(b, {
      get when() {
        return r();
      },
      get fallback() {
        return f(gn);
      },
      get children() {
        return f(fn);
      }
    }), C, D), T.$$click = v, ne(() => h.classList.toggle("visible", !!a())), se(), h;
  })();
};
ke(["click"]);
const hn = ([e, t]) => {
  const n = new K({
    dispatch: (o) => {
      const { options: r } = e(), i = o.newDoc.toString();
      r.hooks.beforeUpdate(i), n.update([o]), o.docChanged && (t({ ...e(), doc: i }), r.hooks.afterUpdate(i));
    },
    state: Me(e())
  });
  return n;
}, bn = () => {
  const [e, t] = U(), n = hn([e, t]), {
    workQueue: o
  } = e();
  return t(Y(e(), {
    editor: n
  })), o.enqueue(async () => {
    const r = await ce(e());
    n.dispatch({
      effects: r
    });
  }), n.dom;
}, xn = /* @__PURE__ */ p('<button class="ink-button" type="button"></button>', 2), M = (e) => (() => {
  const t = f(xn);
  return t.$$click = (n) => e.onclick(n), m(t, () => e.children), se(), t;
})();
ke(["click"]);
const vn = `.ink-mde .ink-mde-toolbar{background-color:var(--ink-internal-block-background-color);color:inherit;display:flex;flex-shrink:0;overflow-x:auto;padding:.25rem}.ink-mde .ink-mde-toolbar .ink-mde-container{display:flex;gap:var(--ink-internal-toolbar-group-spacing)}.ink-mde .ink-mde-toolbar-group{display:flex;gap:var(--ink-internal-toolbar-item-spacing)}.ink-mde .ink-mde-toolbar .ink-button{align-items:center;background:none;border:none;border-radius:var(--ink-internal-border-radius);color:inherit;cursor:pointer;display:flex;height:2.25rem;justify-content:center;padding:.4rem;width:2.25rem}.ink-mde .ink-mde-toolbar .ink-button:hover{background-color:var(--ink-internal-block-background-color-on-hover)}.ink-mde .ink-mde-toolbar .ink-button>*{align-items:center;display:flex;height:100%}
`, yn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6 4V10M6 16V10M6 10H14M14 10V4M14 10V16"></path></svg>', 4), $n = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-width="1.5" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M6.5 10H10.5C12.1569 10 13.5 11.3431 13.5 13C13.5 14.6569 12.1569 16 10.5 16H6.5V4H9.5C11.1569 4 12.5 5.34315 12.5 7C12.5 8.65686 11.1569 10 9.5 10"></path></svg>', 4), wn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M11 4L9 16M13 4H9M7 16H11"></path></svg>', 4), G = /* @__PURE__ */ p('<div class="ink-mde-toolbar-group"><!#><!/><!#><!/><!#><!/></div>', 8), _n = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M2.00257 16H17.9955M2.00055 4H18M7 10H18.0659M2 8.5V11.4999C2.4 11.5 2.5 11.5 2.5 11.5V11V10.5M4 8.5V11.4999H4.5V11V10.5"></path></svg>', 4), Cn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M13 4L7 16"></path><path d="M5 7L2 10L5 13"></path><path d="M15 7L18 10L15 13"></path></svg>', 8), Sn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 4L8 6"></path></svg>', 4), Ln = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M2 16H4"></path><path d="M7 10H17.8294"></path><path d="M2 10H4"></path><path d="M7 4H17.8294"></path><path d="M2 4H4"></path></svg>', 14), Mn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H18"></path><path d="M2 17.0242C2.48314 17.7569 3.94052 17.6154 3.99486 16.7919C4.05315 15.9169 3.1975 16.0044 2.99496 16.0044M2.0023 14.9758C2.48544 14.2431 3.94282 14.3846 3.99716 15.2081C4.05545 16.0831 3.1998 16.0002 2.99726 16.0002"></path><path d="M7 10H18"></path><path d="M2.00501 11.5H4M2.00193 8.97562C2.48449 8.24319 3.9401 8.38467 3.99437 9.20777C4.05259 10.0825 2.04342 10.5788 2 11.4996"></path><path d="M7 4H18"></path><path d="M2 5.5H4M2.99713 5.49952V2.5L2.215 2.93501"></path></svg>', 14), Hn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M7 16H17.8294"></path><path d="M5 15L3 17L2 16"></path><path d="M7 10H17.8294"></path><path d="M5 9L3 11L2 10"></path><path d="M7 4H17.8294"></path><path d="M5 3L3 5L2 4"></path></svg>', 14), An = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M9.12127 10.881C10.02 11.78 11.5237 11.7349 12.4771 10.7813L15.2546 8.00302C16.2079 7.04937 16.253 5.54521 15.3542 4.6462C14.4555 3.74719 12.9512 3.79174 11.9979 4.74539L10.3437 6.40007M10.8787 9.11903C9.97997 8.22002 8.47626 8.26509 7.52288 9.21874L4.74545 11.997C3.79208 12.9506 3.74701 14.4548 4.64577 15.3538C5.54452 16.2528 7.04876 16.2083 8.00213 15.2546L9.65633 13.5999"></path></svg>', 4), zn = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><rect x="2" y="4" width="16" height="12" rx="1"></rect><path d="M7.42659 7.67597L13.7751 13.8831M2.00208 12.9778L7.42844 7.67175"></path><path d="M11.9119 12.0599L14.484 9.54443L17.9973 12.9785"></path><path d="M10.9989 7.95832C11.551 7.95832 11.9986 7.52072 11.9986 6.98092C11.9986 6.44113 11.551 6.00354 10.9989 6.00354C10.4468 6.00354 9.99921 6.44113 9.99921 6.98092C9.99921 7.52072 10.4468 7.95832 10.9989 7.95832Z"></path></svg>', 10), En = /* @__PURE__ */ p('<svg viewBox="0 0 20 20" fill="none" stroke="currentColor" stroke-miterlimit="5" stroke-linecap="round" stroke-linejoin="round"><path d="M10 13V4M10 4L13 7M10 4L7 7"></path><path d="M2 13V15C2 15.5523 2.44772 16 3 16H17C17.5523 16 18 15.5523 18 15V13"></path></svg>', 6), Bn = /* @__PURE__ */ p('<input type="file">', 1), jn = /* @__PURE__ */ p('<div class="ink-mde-toolbar"><style></style><div class="ink-mde-container"><!#><!/><!#><!/><!#><!/><!#><!/></div></div>', 14), Dn = () => {
  const [e, t] = U(), [n, o] = O(), r = (l) => {
    Le([e, t], l), ie([e, t]);
  }, i = (l) => {
    const c = l.target;
    c?.files && Promise.resolve(e().options.files.handler(c.files)).then((u) => {
      const v = `![](${u})`;
      ee([e, t], v), ie([e, t]);
    });
  }, a = () => {
    n()?.click();
  };
  return (() => {
    const l = f(jn), c = l.firstChild, u = c.nextSibling, v = u.firstChild, [w, _] = k(v.nextSibling), L = w.nextSibling, [B, R] = k(L.nextSibling), I = B.nextSibling, [Q, h] = k(I.nextSibling), y = Q.nextSibling, [X, N] = k(y.nextSibling);
    return c.textContent = vn, m(u, s(b, {
      get when() {
        return e().options.toolbar.heading || e().options.toolbar.bold || e().options.toolbar.italic;
      },
      get children() {
        const g = f(G), j = g.firstChild, [C, D] = k(j.nextSibling), T = C.nextSibling, [$, H] = k(T.nextSibling), S = $.nextSibling, [z, E] = k(S.nextSibling);
        return m(g, s(b, {
          get when() {
            return e().options.toolbar.heading;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.Heading),
              get children() {
                return f(yn);
              }
            });
          }
        }), C, D), m(g, s(b, {
          get when() {
            return e().options.toolbar.bold;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.Bold),
              get children() {
                return f($n);
              }
            });
          }
        }), $, H), m(g, s(b, {
          get when() {
            return e().options.toolbar.italic;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.Italic),
              get children() {
                return f(wn);
              }
            });
          }
        }), z, E), g;
      }
    }), w, _), m(u, s(b, {
      get when() {
        return e().options.toolbar.quote || e().options.toolbar.codeBlock || e().options.toolbar.code;
      },
      get children() {
        const g = f(G), j = g.firstChild, [C, D] = k(j.nextSibling), T = C.nextSibling, [$, H] = k(T.nextSibling), S = $.nextSibling, [z, E] = k(S.nextSibling);
        return m(g, s(b, {
          get when() {
            return e().options.toolbar.quote;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.Quote),
              get children() {
                return f(_n);
              }
            });
          }
        }), C, D), m(g, s(b, {
          get when() {
            return e().options.toolbar.codeBlock;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.CodeBlock),
              get children() {
                return f(Cn);
              }
            });
          }
        }), $, H), m(g, s(b, {
          get when() {
            return e().options.toolbar.code;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.Code),
              get children() {
                return f(Sn);
              }
            });
          }
        }), z, E), g;
      }
    }), B, R), m(u, s(b, {
      get when() {
        return e().options.toolbar.list || e().options.toolbar.orderedList || e().options.toolbar.taskList;
      },
      get children() {
        const g = f(G), j = g.firstChild, [C, D] = k(j.nextSibling), T = C.nextSibling, [$, H] = k(T.nextSibling), S = $.nextSibling, [z, E] = k(S.nextSibling);
        return m(g, s(b, {
          get when() {
            return e().options.toolbar.list;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.List),
              get children() {
                return f(Ln);
              }
            });
          }
        }), C, D), m(g, s(b, {
          get when() {
            return e().options.toolbar.orderedList;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.OrderedList),
              get children() {
                return f(Mn);
              }
            });
          }
        }), $, H), m(g, s(b, {
          get when() {
            return e().options.toolbar.taskList;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.TaskList),
              get children() {
                return f(Hn);
              }
            });
          }
        }), z, E), g;
      }
    }), Q, h), m(u, s(b, {
      get when() {
        return e().options.toolbar.link || e().options.toolbar.image || e().options.toolbar.upload;
      },
      get children() {
        const g = f(G), j = g.firstChild, [C, D] = k(j.nextSibling), T = C.nextSibling, [$, H] = k(T.nextSibling), S = $.nextSibling, [z, E] = k(S.nextSibling);
        return m(g, s(b, {
          get when() {
            return e().options.toolbar.link;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.Link),
              get children() {
                return f(An);
              }
            });
          }
        }), C, D), m(g, s(b, {
          get when() {
            return e().options.toolbar.image;
          },
          get children() {
            return s(M, {
              onclick: () => r(x.Image),
              get children() {
                return f(zn);
              }
            });
          }
        }), $, H), m(g, s(b, {
          get when() {
            return e().options.toolbar.upload;
          },
          get children() {
            return s(M, {
              onclick: a,
              get children() {
                return [f(En), (() => {
                  const Z = f(Bn);
                  return he(o, Z), Z.addEventListener("change", i), Z.style.setProperty("display", "none"), Z;
                })()];
              }
            });
          }
        }), z, E), g;
      }
    }), X, N), l;
  })();
}, me = 225, Tn = (e, t = me) => {
  const n = On(e, t), o = Rn(e), r = qn(e), i = Vn(e);
  return [n, o, r, i].join(" | ");
}, Vn = (e) => `${In(e)} chars`, qn = (e) => `${Nn(e)} lines`, On = (e, t = me) => {
  const n = Pn(e, t), o = Math.floor(n), r = Math.floor(n % 1 * 60);
  return o === 0 ? `${r}s read` : `${o}m ${r}s to read`;
}, Rn = (e) => `${Ee(e)} words`, In = (e) => e.length, Nn = (e) => e.split(/\n/).length, Pn = (e, t = me) => Ee(e) / t, Ee = (e) => {
  const t = e.replace(/[']/g, "").replace(/[^\w\d]+/g, " ").trim();
  return t ? t.split(/\s+/).length : 0;
}, Wn = /* @__PURE__ */ p('<div class="ink-mde-readability"><span></span></div>', 4), Fn = /* @__PURE__ */ p("<span>&nbsp;|</span>", 2), Un = /* @__PURE__ */ p('<div class="ink-mde-attribution"><span>&nbsp;powered by <a class="ink-mde-attribution-link" href="https://github.com/voracious/ink-mde" rel="noopener noreferrer" target="_blank">ink-mde</a></span></div>', 6), Qn = /* @__PURE__ */ p('<div class="ink-mde-details"><div class="ink-mde-container"><div class="ink-mde-details-content"><!#><!/><!#><!/><!#><!/></div></div></div>', 12), Xn = () => {
  const [e] = U();
  return (() => {
    const t = f(Qn), n = t.firstChild, o = n.firstChild, r = o.firstChild, [i, a] = k(r.nextSibling), l = i.nextSibling, [c, u] = k(l.nextSibling), v = c.nextSibling, [w, _] = k(v.nextSibling);
    return m(o, s(b, {
      get when() {
        return e().options.readability;
      },
      get children() {
        const L = f(Wn), B = L.firstChild;
        return m(B, () => Tn(e().doc)), L;
      }
    }), i, a), m(o, s(b, {
      get when() {
        return Te(() => !!e().options.readability)() && e().options.interface.attribution;
      },
      get children() {
        return f(Fn);
      }
    }), c, u), m(o, s(b, {
      get when() {
        return e().options.interface.attribution;
      },
      get children() {
        return f(Un);
      }
    }), w, _), t;
  })();
}, Kn = `.ink-mde{border:2px solid var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);color:var(--ink-internal-color, inherit);display:flex;flex-direction:var(--ink-internal-flex-direction, column)}.ink-mde .cm-tooltip{background-color:var(--ink-internal-block-background-color);border-radius:var(--ink-internal-border-radius);font-family:inherit;padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul{font-family:inherit}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option{border-radius:var(--ink-internal-border-radius);padding:.25rem}.ink-mde .cm-tooltip.cm-tooltip-autocomplete ul li.ink-tooltip-option[aria-selected]{background-color:#96969640}.ink-mde .cm-completionLabel{font-family:inherit}.ink-mde,.ink-mde *{box-sizing:border-box}.ink-mde span{display:inline-block}.ink-mde,.ink-mde .ink-mde-editor{display:flex;flex-direction:column;flex-grow:1;flex-shrink:1;min-height:0}.ink-mde .ink-mde-editor{overflow:auto;padding:.5rem}.ink-mde .ink-mde-toolbar,.ink-mde .ink-mde-details{display:flex;flex-grow:0;flex-shrink:0}.ink-mde .ink-mde-details{background-color:var(--ink-internal-block-background-color);display:flex;padding:.5rem}.ink-mde .ink-mde-details-content{color:inherit;display:flex;filter:brightness(.75);flex-wrap:wrap;font-size:.75em;justify-content:flex-end}.ink-mde .ink-mde-attribution{display:flex;justify-content:flex-end}.ink-mde .ink-mde-attribution-link{color:currentColor;font-weight:600;text-decoration:none}.ink-mde .ink-mde-container{margin-left:auto;margin-right:auto;width:100%}.ink-mde .ink-mde-search-panel{background-color:var(--ink-internal-block-background-color);border-radius:.25rem;padding:.25rem;position:absolute;right:.25rem;top:.25rem;width:clamp(10rem,30%,100%)}.ink-mde .ink-mde-search-panel:focus-within{outline-color:#6495ed;outline-style:solid}.ink-mde .ink-mde-search-input{background-color:transparent;border:none;border-radius:.25rem;color:inherit;font-size:inherit;outline:none;width:100%}.ink-mde .ink-mde-task-toggle{cursor:pointer;height:1rem;line-height:2em;margin:0 .25rem 0 0;position:relative;top:-1px;vertical-align:middle;width:1rem}.ink-mde .cm-editor{display:flex;flex-direction:column;position:relative}.ink-mde .cm-panels{background-color:unset;border:unset;z-index:10}.ink-mde .cm-searchMatch{background-color:#6495ed50}.ink-mde .cm-searchMatch-selected{background-color:#6495edcc}.ink-mde .cm-scroller{align-items:flex-start;display:flex;font-family:var(--ink-internal-font-family);font-size:var(--ink-internal-editor-font-size);line-height:var(--ink-internal-editor-line-height);overflow-x:auto;position:relative}.ink-mde .cm-content{display:block;flex-grow:2;flex-shrink:0;margin:0;outline:none;padding:0;white-space:pre;word-wrap:normal}.ink-mde .cm-lineWrapping{flex-shrink:1;overflow-wrap:anywhere;white-space:break-spaces;word-break:break-word}.ink-mde .cm-line{font-family:var(--ink-internal-font-family);padding:0}.ink-mde .cm-line.cm-blockquote{background-color:var(--ink-internal-block-background-color);border-left:.25rem solid currentColor;padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-open{border-top-left-radius:var(--ink-internal-border-radius);border-top-right-radius:var(--ink-internal-border-radius);padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-blockquote.cm-blockquote-close{border-bottom-left-radius:var(--ink-internal-border-radius);border-bottom-right-radius:var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:0 var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-open{border-radius:var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0 0;padding-top:var(--ink-internal-block-padding)}.ink-mde .cm-line.cm-codeblock.cm-codeblock-close{border-radius:0 0 var(--ink-internal-border-radius) var(--ink-internal-border-radius);padding-bottom:var(--ink-internal-block-padding)}.ink-mde .cm-line .cm-code{background-color:var(--ink-internal-block-background-color);font-family:var(--ink-internal-code-font-family);padding:var(--ink-internal-inline-padding) 0}.ink-mde .cm-line .cm-code.cm-code-open{border-radius:var(--ink-internal-border-radius) 0 0 var(--ink-internal-border-radius);padding-left:var(--ink-internal-inline-padding)}.ink-mde .cm-line .cm-code.cm-code-close{border-radius:0 var(--ink-internal-border-radius) var(--ink-internal-border-radius) 0;padding-right:var(--ink-internal-inline-padding)}.ink-mde .cm-image-backdrop{background-color:var(--ink-internal-block-background-color)}
`, Yn = /* @__PURE__ */ p("<style> </style>", 2), Zn = () => {
  const [e] = U(), [t, n] = O(te(e()));
  return Pe(() => {
    n(te(e()));
  }), be(() => {
    const o = window.matchMedia("(prefers-color-scheme: dark)"), r = (i) => {
      const {
        editor: a,
        root: l,
        workQueue: c
      } = e();
      l.isConnected ? c.enqueue(async () => {
        const u = await ce(e());
        a.dispatch({
          effects: u
        }), n(te(e()));
      }) : o.removeEventListener("change", r);
    };
    o.addEventListener("change", r);
  }), (() => {
    const o = f(Yn), r = o.firstChild;
    return ne(() => r.data = `.ink {
  ${t().join(`
  `)}
}
${Kn}`), o;
  })();
}, Gn = /* @__PURE__ */ p('<div class="ink ink-mde"><!#><!/><!#><!/><!#><!/><div class="ink-mde-editor"></div><!#><!/></div>', 12), Jn = () => {
  const [e, t] = U(), n = (o) => {
    t(Y(e(), {
      root: o
    }));
  };
  return (() => {
    const o = f(Gn), r = o.firstChild, [i, a] = k(r.nextSibling), l = i.nextSibling, [c, u] = k(l.nextSibling), v = c.nextSibling, [w, _] = k(v.nextSibling), L = w.nextSibling, B = L.nextSibling, [R, I] = k(B.nextSibling);
    return he(n, o), Ve(o, qe(ct), !1, !0), m(o, s(Zn, {}), i, a), m(o, s(b, {
      get when() {
        return e().options.files.clipboard || e().options.files.dragAndDrop;
      },
      get children() {
        return s(kn, {});
      }
    }), c, u), m(o, s(b, {
      get when() {
        return e().options.interface.toolbar;
      },
      get children() {
        return s(Dn, {});
      }
    }), w, _), m(L, s(bn, {})), m(o, s(b, {
      get when() {
        return e().options.readability || e().options.interface.attribution;
      },
      get children() {
        return s(Xn, {
          store: [e, t]
        });
      }
    }), R, I), se(), o;
  })();
}, Be = We([() => re(), (e) => typeof e == "function" ? e(re()) : e]), eo = (e) => s(Be.Provider, {
  get value() {
    return e.store;
  },
  get children() {
    return e.children;
  }
}), U = () => Fe(Be), je = (e) => s(eo, {
  get store() {
    return e.store;
  },
  get children() {
    return s(Jn, {
      get store() {
        return e.store;
      }
    });
  }
}), to = /* @__PURE__ */ p('<div class="ink-mde-textarea"></div>', 2), po = (e) => e, no = (e, t = {}) => {
  const n = de(t);
  return oo(), Oe(() => s(je, {
    store: n
  }), e), ze(n);
}, go = (e, t = {}) => e.querySelector(lt) ? no(e, t) : De(e, t), De = (e, t = {}) => {
  const n = de(t);
  return Re(() => s(je, {
    store: n
  }), e), ze(n);
}, ko = (e = {}) => (de(e), ""), oo = () => {
  let e, t;
  e = window._$HY || (window._$HY = {
    events: [],
    completed: /* @__PURE__ */ new WeakSet(),
    r: {}
  }), t = (n) => n && n.hasAttribute && (n.hasAttribute("data-hk") ? n : t(n.host && n.host instanceof Node ? n.host : n.parentNode)), ["click", "input"].forEach((n) => document.addEventListener(n, (o) => {
    let r = o.composedPath && o.composedPath()[0] || o.target, i = t(r);
    i && !e.completed.has(i) && e.events.push([i, o]);
  })), e.init = (n, o) => {
    e.r[n] = [new Promise((r, i) => o = r), o];
  }, e.set = (n, o, r) => {
    (r = e.r[n]) && r[1](o), e.r[n] = [o];
  }, e.unset = (n) => {
    delete e.r[n];
  }, e.load = (n, o) => {
    if (o = e.r[n])
      return o[0];
  };
}, ho = (e, t = {}) => {
  const n = f(to);
  e.after(n), e.style.display = "none";
  const o = De(e, t);
  return e.form && e.form.addEventListener("submit", () => {
    e.value = o.getDoc();
  }), o;
};
export {
  W as Appearance,
  ft as Extensions,
  x as Markup,
  J as PluginType,
  oe as Selection,
  go as default,
  po as defineOptions,
  no as hydrate,
  go as ink,
  De as render,
  ko as renderToString,
  oo as solidPrepareForHydration,
  ho as wrap
};
//# sourceMappingURL=client.js.map
